// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from nerian_stereo:msg/StereoCameraInfo.idl
// generated code does not contain a copyright notice

#ifndef NERIAN_STEREO__MSG__DETAIL__STEREO_CAMERA_INFO__FUNCTIONS_H_
#define NERIAN_STEREO__MSG__DETAIL__STEREO_CAMERA_INFO__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "nerian_stereo/msg/rosidl_generator_c__visibility_control.h"

#include "nerian_stereo/msg/detail/stereo_camera_info__struct.h"

/// Initialize msg/StereoCameraInfo message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * nerian_stereo__msg__StereoCameraInfo
 * )) before or use
 * nerian_stereo__msg__StereoCameraInfo__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
bool
nerian_stereo__msg__StereoCameraInfo__init(nerian_stereo__msg__StereoCameraInfo * msg);

/// Finalize msg/StereoCameraInfo message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
void
nerian_stereo__msg__StereoCameraInfo__fini(nerian_stereo__msg__StereoCameraInfo * msg);

/// Create msg/StereoCameraInfo message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * nerian_stereo__msg__StereoCameraInfo__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
nerian_stereo__msg__StereoCameraInfo *
nerian_stereo__msg__StereoCameraInfo__create();

/// Destroy msg/StereoCameraInfo message.
/**
 * It calls
 * nerian_stereo__msg__StereoCameraInfo__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
void
nerian_stereo__msg__StereoCameraInfo__destroy(nerian_stereo__msg__StereoCameraInfo * msg);


/// Initialize array of msg/StereoCameraInfo messages.
/**
 * It allocates the memory for the number of elements and calls
 * nerian_stereo__msg__StereoCameraInfo__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
bool
nerian_stereo__msg__StereoCameraInfo__Sequence__init(nerian_stereo__msg__StereoCameraInfo__Sequence * array, size_t size);

/// Finalize array of msg/StereoCameraInfo messages.
/**
 * It calls
 * nerian_stereo__msg__StereoCameraInfo__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
void
nerian_stereo__msg__StereoCameraInfo__Sequence__fini(nerian_stereo__msg__StereoCameraInfo__Sequence * array);

/// Create array of msg/StereoCameraInfo messages.
/**
 * It allocates the memory for the array and calls
 * nerian_stereo__msg__StereoCameraInfo__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
nerian_stereo__msg__StereoCameraInfo__Sequence *
nerian_stereo__msg__StereoCameraInfo__Sequence__create(size_t size);

/// Destroy array of msg/StereoCameraInfo messages.
/**
 * It calls
 * nerian_stereo__msg__StereoCameraInfo__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_nerian_stereo
void
nerian_stereo__msg__StereoCameraInfo__Sequence__destroy(nerian_stereo__msg__StereoCameraInfo__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // NERIAN_STEREO__MSG__DETAIL__STEREO_CAMERA_INFO__FUNCTIONS_H_
